CON
  CD  = 9                                               ' Propeller Pin 4 - Uncomment this line if you are using the Chip Detect function on the card. See below. 
  CS  = 14                                              ' Propeller Pin 3 - Set up these pins to match the Parallax Micro SD Card adapter connections.
  DI  = 13                                              ' Propeller Pin 2 - For additional information, download and refer to the Parallax PDF file for the Micro SD Adapter.                        
  CLK = 12                                              ' Propeller Pin 1 - The pins shown here are the correct pin numbers for my Micro SD Card adapter from Parallax                               
  D0  = 11                                              ' Propeller Pin 0 - In addition to these pins, make the power connections as shown in the following comment block.

OBJ
  sdfat : "fsrw"                                        ' Download the fswr.spin object from the Parallax Propeller Object Exchange (OBEX), accessed from parallax.com
  pst   : "Parallax Serial Terminal"                    ' If you don't already have it in your working directory, you can also download this object from OBEX.

var
  long year
  byte month
  byte day
  byte hour
  byte minute

  byte filename[13]       
  byte card_data[11]
  long stack_clock[100]
   
PUB ini | insert_card
  pst.Start(115_200)
  waitcnt(clkfreq*6+cnt)
                                                              
  insert_card := \sdfat.mount_explicit(D0, CLK, DI, CS)                         
  if insert_card < 0
    pst.str(string(13,"The Micro SD Card was not found!"))                         
    pst.str(string(13,"Insert card, or check your connections.")) 
    abort                                                      
  else
     pst.str(string(13,"Micro SD card was found!",13))

  time_set
  pst.stop
  cognew(clock, @stack_clock) 
    
pub Time_set
  pst.str(string(13,"please enter month         :"))
  month:=pst.decin
  
  pst.str(string(13,"please enter day           :"))
  day:=pst.decin
  
  pst.str(string(13,"please enter year          :"))
  year:=pst.decin

  pst.str(string(13,"please enter hour          :"))
  hour:=pst.decin                         

  pst.str(string(13,"please enter minute        :"))
  minute:=pst.decin
   
pub log_data(value) 
  get_file_name
  get_card_data(value)
  
  sdfat.popen(@filename ,"a")                     
         
  sdfat.pputs(string(13,10))                                                      ' CR/LF

  sdfat.pputs(@card_data)                                                

  sdfat.pclose                                                                  

pub get_file_name
  bytemove(@filename,string("00_00_00.txt"),13)
  filename[0]+=month/10
  filename[1]+=month//10
  filename[3]+=day/10
  filename[4]+=day//10
  filename[6]+=(((year//1000)//100)/10)
  filename[7]+=(((year//1000)//100)//10)

pub get_card_data(value)
  bytemove(@card_data,string("00:00,000,"),11)
  card_data[0]+=hour/10
  card_data[1]+=hour//10
  card_data[3]+=minute/10
  card_data[4]+=minute//10
  card_data[6]+=value/100
  card_data[7]+=((value//100)/10)
  card_data[8]+=(value//10)
  
pub end
  sdfat.unmount

pub clock | seconds,dT,T

  dT := clkfreq
  T := cnt
  seconds:=0
  repeat 
    T += dT
    waitcnt(T)
    seconds ++
    if seconds == 60
      seconds:=0
      minute++
      if minute==60
        minute:=0
        hour++
        if hour==24
          hour:=0
          day++
 